/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.ajp.portal.model;

import aQute.bnd.annotation.ProviderType;

import com.liferay.expando.kernel.model.ExpandoBridge;
import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.model.BaseModel;
import com.liferay.portal.kernel.model.CacheModel;
import com.liferay.portal.kernel.model.GroupedModel;
import com.liferay.portal.kernel.model.ShardedModel;
import com.liferay.portal.kernel.model.StagedAuditedModel;
import com.liferay.portal.kernel.model.WorkflowedModel;
import com.liferay.portal.kernel.service.ServiceContext;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the LegalCase service. Represents a row in the &quot;ajp_LegalCase&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation <code>com.ajp.portal.model.impl.LegalCaseModelImpl</code> exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in <code>com.ajp.portal.model.impl.LegalCaseImpl</code>.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see LegalCase
 * @generated
 */
@ProviderType
public interface LegalCaseModel
	extends BaseModel<LegalCase>, GroupedModel, ShardedModel,
			StagedAuditedModel, WorkflowedModel {

	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a legal case model instance should use the {@link LegalCase} interface instead.
	 */

	/**
	 * Returns the primary key of this legal case.
	 *
	 * @return the primary key of this legal case
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this legal case.
	 *
	 * @param primaryKey the primary key of this legal case
	 */
	public void setPrimaryKey(long primaryKey);

	/**
	 * Returns the uuid of this legal case.
	 *
	 * @return the uuid of this legal case
	 */
	@AutoEscape
	@Override
	public String getUuid();

	/**
	 * Sets the uuid of this legal case.
	 *
	 * @param uuid the uuid of this legal case
	 */
	@Override
	public void setUuid(String uuid);

	/**
	 * Returns the legal case ID of this legal case.
	 *
	 * @return the legal case ID of this legal case
	 */
	public long getLegalCaseId();

	/**
	 * Sets the legal case ID of this legal case.
	 *
	 * @param legalCaseId the legal case ID of this legal case
	 */
	public void setLegalCaseId(long legalCaseId);

	/**
	 * Returns the group ID of this legal case.
	 *
	 * @return the group ID of this legal case
	 */
	@Override
	public long getGroupId();

	/**
	 * Sets the group ID of this legal case.
	 *
	 * @param groupId the group ID of this legal case
	 */
	@Override
	public void setGroupId(long groupId);

	/**
	 * Returns the company ID of this legal case.
	 *
	 * @return the company ID of this legal case
	 */
	@Override
	public long getCompanyId();

	/**
	 * Sets the company ID of this legal case.
	 *
	 * @param companyId the company ID of this legal case
	 */
	@Override
	public void setCompanyId(long companyId);

	/**
	 * Returns the user ID of this legal case.
	 *
	 * @return the user ID of this legal case
	 */
	@Override
	public long getUserId();

	/**
	 * Sets the user ID of this legal case.
	 *
	 * @param userId the user ID of this legal case
	 */
	@Override
	public void setUserId(long userId);

	/**
	 * Returns the user uuid of this legal case.
	 *
	 * @return the user uuid of this legal case
	 */
	@Override
	public String getUserUuid();

	/**
	 * Sets the user uuid of this legal case.
	 *
	 * @param userUuid the user uuid of this legal case
	 */
	@Override
	public void setUserUuid(String userUuid);

	/**
	 * Returns the user name of this legal case.
	 *
	 * @return the user name of this legal case
	 */
	@AutoEscape
	@Override
	public String getUserName();

	/**
	 * Sets the user name of this legal case.
	 *
	 * @param userName the user name of this legal case
	 */
	@Override
	public void setUserName(String userName);

	/**
	 * Returns the create date of this legal case.
	 *
	 * @return the create date of this legal case
	 */
	@Override
	public Date getCreateDate();

	/**
	 * Sets the create date of this legal case.
	 *
	 * @param createDate the create date of this legal case
	 */
	@Override
	public void setCreateDate(Date createDate);

	/**
	 * Returns the modified date of this legal case.
	 *
	 * @return the modified date of this legal case
	 */
	@Override
	public Date getModifiedDate();

	/**
	 * Sets the modified date of this legal case.
	 *
	 * @param modifiedDate the modified date of this legal case
	 */
	@Override
	public void setModifiedDate(Date modifiedDate);

	/**
	 * Returns the status of this legal case.
	 *
	 * @return the status of this legal case
	 */
	@Override
	public int getStatus();

	/**
	 * Sets the status of this legal case.
	 *
	 * @param status the status of this legal case
	 */
	@Override
	public void setStatus(int status);

	/**
	 * Returns the status by user ID of this legal case.
	 *
	 * @return the status by user ID of this legal case
	 */
	@Override
	public long getStatusByUserId();

	/**
	 * Sets the status by user ID of this legal case.
	 *
	 * @param statusByUserId the status by user ID of this legal case
	 */
	@Override
	public void setStatusByUserId(long statusByUserId);

	/**
	 * Returns the status by user uuid of this legal case.
	 *
	 * @return the status by user uuid of this legal case
	 */
	@Override
	public String getStatusByUserUuid();

	/**
	 * Sets the status by user uuid of this legal case.
	 *
	 * @param statusByUserUuid the status by user uuid of this legal case
	 */
	@Override
	public void setStatusByUserUuid(String statusByUserUuid);

	/**
	 * Returns the status by user name of this legal case.
	 *
	 * @return the status by user name of this legal case
	 */
	@AutoEscape
	@Override
	public String getStatusByUserName();

	/**
	 * Sets the status by user name of this legal case.
	 *
	 * @param statusByUserName the status by user name of this legal case
	 */
	@Override
	public void setStatusByUserName(String statusByUserName);

	/**
	 * Returns the status date of this legal case.
	 *
	 * @return the status date of this legal case
	 */
	@Override
	public Date getStatusDate();

	/**
	 * Sets the status date of this legal case.
	 *
	 * @param statusDate the status date of this legal case
	 */
	@Override
	public void setStatusDate(Date statusDate);

	/**
	 * Returns the title of this legal case.
	 *
	 * @return the title of this legal case
	 */
	@AutoEscape
	public String getTitle();

	/**
	 * Sets the title of this legal case.
	 *
	 * @param title the title of this legal case
	 */
	public void setTitle(String title);

	/**
	 * Returns the description of this legal case.
	 *
	 * @return the description of this legal case
	 */
	@AutoEscape
	public String getDescription();

	/**
	 * Sets the description of this legal case.
	 *
	 * @param description the description of this legal case
	 */
	public void setDescription(String description);

	/**
	 * Returns the decision date of this legal case.
	 *
	 * @return the decision date of this legal case
	 */
	public Date getDecisionDate();

	/**
	 * Sets the decision date of this legal case.
	 *
	 * @param decisionDate the decision date of this legal case
	 */
	public void setDecisionDate(Date decisionDate);

	/**
	 * Returns the country category ID of this legal case.
	 *
	 * @return the country category ID of this legal case
	 */
	public long getCountryCategoryId();

	/**
	 * Sets the country category ID of this legal case.
	 *
	 * @param countryCategoryId the country category ID of this legal case
	 */
	public void setCountryCategoryId(long countryCategoryId);

	/**
	 * Returns the subarea category ID of this legal case.
	 *
	 * @return the subarea category ID of this legal case
	 */
	public long getSubareaCategoryId();

	/**
	 * Sets the subarea category ID of this legal case.
	 *
	 * @param subareaCategoryId the subarea category ID of this legal case
	 */
	public void setSubareaCategoryId(long subareaCategoryId);

	/**
	 * Returns the summary file entry ID of this legal case.
	 *
	 * @return the summary file entry ID of this legal case
	 */
	public long getSummaryFileEntryId();

	/**
	 * Sets the summary file entry ID of this legal case.
	 *
	 * @param summaryFileEntryId the summary file entry ID of this legal case
	 */
	public void setSummaryFileEntryId(long summaryFileEntryId);

	/**
	 * Returns the judgement file entry ID of this legal case.
	 *
	 * @return the judgement file entry ID of this legal case
	 */
	public long getJudgementFileEntryId();

	/**
	 * Sets the judgement file entry ID of this legal case.
	 *
	 * @param judgementFileEntryId the judgement file entry ID of this legal case
	 */
	public void setJudgementFileEntryId(long judgementFileEntryId);

	/**
	 * Returns the url of this legal case.
	 *
	 * @return the url of this legal case
	 */
	@AutoEscape
	public String getUrl();

	/**
	 * Sets the url of this legal case.
	 *
	 * @param url the url of this legal case
	 */
	public void setUrl(String url);

	/**
	 * Returns <code>true</code> if this legal case is approved.
	 *
	 * @return <code>true</code> if this legal case is approved; <code>false</code> otherwise
	 */
	@Override
	public boolean isApproved();

	/**
	 * Returns <code>true</code> if this legal case is denied.
	 *
	 * @return <code>true</code> if this legal case is denied; <code>false</code> otherwise
	 */
	@Override
	public boolean isDenied();

	/**
	 * Returns <code>true</code> if this legal case is a draft.
	 *
	 * @return <code>true</code> if this legal case is a draft; <code>false</code> otherwise
	 */
	@Override
	public boolean isDraft();

	/**
	 * Returns <code>true</code> if this legal case is expired.
	 *
	 * @return <code>true</code> if this legal case is expired; <code>false</code> otherwise
	 */
	@Override
	public boolean isExpired();

	/**
	 * Returns <code>true</code> if this legal case is inactive.
	 *
	 * @return <code>true</code> if this legal case is inactive; <code>false</code> otherwise
	 */
	@Override
	public boolean isInactive();

	/**
	 * Returns <code>true</code> if this legal case is incomplete.
	 *
	 * @return <code>true</code> if this legal case is incomplete; <code>false</code> otherwise
	 */
	@Override
	public boolean isIncomplete();

	/**
	 * Returns <code>true</code> if this legal case is pending.
	 *
	 * @return <code>true</code> if this legal case is pending; <code>false</code> otherwise
	 */
	@Override
	public boolean isPending();

	/**
	 * Returns <code>true</code> if this legal case is scheduled.
	 *
	 * @return <code>true</code> if this legal case is scheduled; <code>false</code> otherwise
	 */
	@Override
	public boolean isScheduled();

	@Override
	public boolean isNew();

	@Override
	public void setNew(boolean n);

	@Override
	public boolean isCachedModel();

	@Override
	public void setCachedModel(boolean cachedModel);

	@Override
	public boolean isEscapedModel();

	@Override
	public Serializable getPrimaryKeyObj();

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	@Override
	public ExpandoBridge getExpandoBridge();

	@Override
	public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

	@Override
	public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	@Override
	public Object clone();

	@Override
	public int compareTo(LegalCase legalCase);

	@Override
	public int hashCode();

	@Override
	public CacheModel<LegalCase> toCacheModel();

	@Override
	public LegalCase toEscapedModel();

	@Override
	public LegalCase toUnescapedModel();

	@Override
	public String toString();

	@Override
	public String toXmlString();

}